import processing.serial.*;

/*
A little example using the classic "Eliza" program.

Eliza was compiled as a Processing library, based on the
java source code by Charles Hayden:
htp://www.chayden.net/eliza/Eliza.html

The default script that determines Eliza's behaviour can be 
changed with the readScript() function.
Intructions to modify the script file are available here:
http://www.chayden.net/eliza/instructions.txt
*/

// max is 67 on sweep

import codeanticode.eliza.*;
Serial myport;
int dummy=8;
int sendx=0;
Serial myport2; // neck motor
int drawskeleton=0;  //1 / 0
int lastsentx=-1;
int lastsenty=-1;

int archsenty=-1;
int archsentx=-1;


int eyecount=0; //used for sampling movement

Eliza eliza;
PFont font;
String elizaResponse, humanResponse;
boolean showCursor;
int lastTime;
PImage bg1a;


int closestValue; 
int closestX;
int closestY;
int lastcx;
int lastcy;

float targx;
float targy;


//simple openni
import SimpleOpenNI.*;
float globx, globy;
float oldglobx, oldgloby;
SimpleOpenNI  context;
color[]       userClr = new color[]{ color(255,0,0),
                                     color(0,255,0),
                                     color(0,0,255),
                                     color(255,255,0),
                                     color(255,0,255),
                                     color(0,255,255)
                                   };
PVector com = new PVector();                                   
PVector com2d = new PVector();           
//end simpleopenni

void setup()
{
    size(1200, 786);
    println(sketchPath);
    //si
     context = new SimpleOpenNI(this);
  if(context.isInit() == false)
  {
     //println("Can't init SimpleOpenNI, maybe the camera is not connected!"); 
     exit();
     return;  
  }
  
  // enable depthMap generation 
  context.enableDepth();
   
  // enable skeleton generation for all joints
 // context.enableUser();
 
  background(200,0,0);
  //end si //<>//
  
    bg1a=loadImage("bg1.jpg");
     //println(Serial.list());
myport=new Serial(this, Serial.list()[5],9600);
//myport2=new Serial(this, Serial.list()[??????],9600);
    // When Eliza is initialized, a default script built into the
    // library is loaded.
    eliza = new Eliza(this);
  
    // A new script can be loaded through the readScript function.
    // It can take local as well as remote files. 
    
    
    eliza.readScript("scriptnew.txt");
    //eliza.readScript("http://chayden.net/eliza/script");
  
    // To go back to the default script, use this:
    //eliza.readDefaultScript();
  
    font = loadFont("Rockwell-24.vlw");
    textFont(font);

    printElizaIntro();
    humanResponse = "";
    showCursor = true;
    lastTime = 0;
}

void draw()
{
  
  while(myport.available()>0){
    int dat=myport.read();
   /// println(""+dat);
   
    
  }
  
  
  eyecount++;
 //println("EYECOUNT:"+eyecount);
  if(eyecount>=30){
    
    println("diffx="+abs(closestX-lastcx)+"  diffy="+abs(closestX-lastcy));
    
   // println(archsenty+" "+closestY+" "+archsentx+" "+lastsentx);
    
    //if(archsenty==-1) archsenty=lastsenty;
    //if(archsentx==-1) archsentx=lastsentx;
    
    if(abs(closestY-lastcy)<30 && abs(closestX-lastcx)<30){
    //  archsenty=lastsenty;
     // archsentx=lastsentx;
     // for(int lop=0;lop<100;lop++){
     println("WOULD GO INTO EYE TWITCHING");
    //  myport.write(201);
      lastcx=closestX;
      lastcy=closestY;
     
      
    }else{
      //if(abs(lastsenty-archsenty)>45 && abs(lastsentx-archsentx)<45){
       println("WOULD GO BACK TO MOVEMENT");
        lastcx=closestX;
      lastcy=closestY;
     // myport.write(202);
     // }
    }
    
      
    eyecount=0;
    
  }
  
  image(bg1a,0,0,width,height);
    //background(102);
if(globx!=oldglobx){
  sendx=int(abs(globx));
 // sendx=8+(sendx/8);
  
  oldglobx=globx;
  
  
 //  myport.write(sendx);
  
}
if( sendx>9 && lastsentx!=sendx){
  //println("sending neck positions"+sendx);
  if(abs(lastsentx-sendx)>35) eyecount=145;
  myport.write(sendx); // UNCOMMENT FOR PEOPLE TRACKING
 lastsentx=sendx;
 
  
}
//println("neck y:"+int(globy));
if(random(10)>4){
  int outy=70+int(globy);
  if(outy>200) outy=200;
//println("outy="+outy);

//HERE IS THE LINE SENDING THE NECK Y COORDINATES
 if(lastsenty!=outy){
   if(abs(lastsenty-outy)>35) eyecount=145;
   
   myport.write(outy);
   //println("OUTY:"+outy);
   lastsenty=outy;
 }
}

//DUMMY SWEEP STARTS HERE
if(random(10)>2){
 // myport.write(dummy);
////println("DUMMY:"+dummy);
//dummy++;
//if(dummy>170) dummy=9;

//myport.write((70+dummy));
////println("neckyyyyyyyy"+(70+dummy));
}
//DUMMY SWEEP ENDS HERE


    fill(255);
    stroke (111);
    text(elizaResponse, 30, 450, width - 40, height);

    fill(0);

    int t = millis();
    if (t - lastTime > 500)
    {
        showCursor = !showCursor;
        lastTime = t;
    }
    
    if (showCursor) text(humanResponse + "_", 30, 600, width - 40, height);
    else text(humanResponse, 30, 600, width - 40, height);
    
  //  simpleopennidrawmethod();
    closestpixdrawmethod();
    
}


void  closestpixdrawmethod(){
  
   closestValue = 8000; 

 context.update();

  // get the depth array from the kinect
  int[] depthValues = context.depthMap();

  // for each row in the depth image
  for(int y = 0; y < 480; y++){ 

    // look at each pixel in the row
    for(int x = 0; x < 640; x++){ 
      // pull out the corresponding value from the depth array
      int i = x + y * 640; 
      int currentDepthValue = depthValues[i];

      // if that pixel is the closest one we've seen so far
      if(currentDepthValue > 0 && currentDepthValue < closestValue){ 
        // save its value
        closestValue = currentDepthValue;
        // and save its position (both X and Y coordinates)
        closestX = x;
        closestY = y;
      }
    }
  }
  
  
  float scfac=67.0/640;
  globx=(closestX*scfac)*.7;
  targy=(closestY*scfac)*3.2;
  globy=globy+((targy-globy)/8);
//  globy=targy;
 // //println(globx);
  

  //draw the depth image on the screen
//  image(kinect.depthImage(),0,0);

  // draw a red circle over it,
  // positioned at the X and Y coordinates
  // we saved of the closest pixel.
 // fill(255,0,0);
 // ellipse(closestX, closestY, 25, 25);
  
  
}


void keyPressed() 
{
    if ((key == ENTER) || (key == RETURN)) 
    {
        //println(humanResponse);
        
        
        //first scan for keywords
        
        
        
        elizaResponse = eliza.processInput(humanResponse);
        //println(">> " + elizaResponse);
        
        String[] out={elizaResponse};
        saveStrings("/Users/carlstrathearn/Desktop/test.txt",out);
        delay(10);
        
        
        
        
        //println(sketchPath+"/data/applescriptbridge.app");
        open(sketchPath+"/data/applescriptbridge.app");
        myport.write(1);
        
        
        humanResponse = "";
    } 
    else if ((key > 31) && (key != CODED)) 
    {
        // If the key is alphanumeric, add it to the String
        humanResponse = humanResponse + key;
    }
    else if ((key == BACKSPACE) && (0 < humanResponse.length()))
    {
        char c = humanResponse.charAt(humanResponse.length() - 1);
        humanResponse = humanResponse.substring(0, humanResponse.length() - 1);
    }
}

void printElizaIntro()
{
    String hello = "Hello.";
    elizaResponse = hello + " " + eliza.processInput(hello);
    //println(">> " + elizaResponse);
}

void simpleopennidrawmethod(){
  
   
  context.update();
 // //println("gx="+globx+"  GY="+globy);
  // draw depthImageMap
  //image(context.depthImage(),0,0);
  if(drawskeleton==1) image(context.userImage(),0,0);
  
  // draw the skeleton if it's available
  int[] userList = context.getUsers();
  for(int i=0;i<userList.length;i++)
  {
    if(context.isTrackingSkeleton(userList[i]))
    {
      stroke(userClr[ (userList[i] - 1) % userClr.length ] );
      drawSkeleton(userList[i]);
    }      
      
    // draw the center of mass
    if(context.getCoM(userList[i],com))
    {
      context.convertRealWorldToProjective(com,com2d);
      stroke(100,255,0);
      strokeWeight(1);
      if(drawskeleton==1){
      beginShape(LINES);
        vertex(com2d.x,com2d.y - 5);
        vertex(com2d.x,com2d.y + 5);

        vertex(com2d.x - 5,com2d.y);
        vertex(com2d.x + 5,com2d.y);
      endShape();
      
      fill(0,255,100);
      text(Integer.toString(userList[i]),com2d.x,com2d.y);
      }
    }
  }    
  
}


void drawSkeleton(int userId)
{
  // to get the 3d joint data
  /*
  PVector jointPos = new PVector();
  context.getJointPositionSkeleton(userId,SimpleOpenNI.SKEL_NECK,jointPos);
  //println(jointPos);
  */
  
 // //println(SimpleOpenNI.SKEL_HEAD);
 
  if(random(100)>97){
  PVector jointPos = new PVector();
context.getJointPositionSkeleton(userId,SimpleOpenNI.SKEL_HEAD,jointPos);
//println(jointPos.x);
//println(jointPos.y);
//println(jointPos.z);
globx=jointPos.x;
globy=jointPos.y;

  }

if(drawskeleton==1){
 context.drawLimb(userId, SimpleOpenNI.SKEL_HEAD, SimpleOpenNI.SKEL_NECK);
  context.drawLimb(userId, SimpleOpenNI.SKEL_NECK, SimpleOpenNI.SKEL_LEFT_SHOULDER);
  context.drawLimb(userId, SimpleOpenNI.SKEL_LEFT_SHOULDER, SimpleOpenNI.SKEL_LEFT_ELBOW);
  context.drawLimb(userId, SimpleOpenNI.SKEL_LEFT_ELBOW, SimpleOpenNI.SKEL_LEFT_HAND);

  context.drawLimb(userId, SimpleOpenNI.SKEL_NECK, SimpleOpenNI.SKEL_RIGHT_SHOULDER);
  context.drawLimb(userId, SimpleOpenNI.SKEL_RIGHT_SHOULDER, SimpleOpenNI.SKEL_RIGHT_ELBOW);
  context.drawLimb(userId, SimpleOpenNI.SKEL_RIGHT_ELBOW, SimpleOpenNI.SKEL_RIGHT_HAND);

  context.drawLimb(userId, SimpleOpenNI.SKEL_LEFT_SHOULDER, SimpleOpenNI.SKEL_TORSO);
  context.drawLimb(userId, SimpleOpenNI.SKEL_RIGHT_SHOULDER, SimpleOpenNI.SKEL_TORSO);

  context.drawLimb(userId, SimpleOpenNI.SKEL_TORSO, SimpleOpenNI.SKEL_LEFT_HIP);
  context.drawLimb(userId, SimpleOpenNI.SKEL_LEFT_HIP, SimpleOpenNI.SKEL_LEFT_KNEE);
  context.drawLimb(userId, SimpleOpenNI.SKEL_LEFT_KNEE, SimpleOpenNI.SKEL_LEFT_FOOT);

  context.drawLimb(userId, SimpleOpenNI.SKEL_TORSO, SimpleOpenNI.SKEL_RIGHT_HIP);
  context.drawLimb(userId, SimpleOpenNI.SKEL_RIGHT_HIP, SimpleOpenNI.SKEL_RIGHT_KNEE);
  context.drawLimb(userId, SimpleOpenNI.SKEL_RIGHT_KNEE, SimpleOpenNI.SKEL_RIGHT_FOOT);  
}

}

// -----------------------------------------------------------------
// SimpleOpenNI events

void onNewUser(SimpleOpenNI curContext, int userId)
{
  //println("onNewUser - userId: " + userId);
  //println("\tstart tracking skeleton");
  
  curContext.startTrackingSkeleton(userId);
}

void onLostUser(SimpleOpenNI curContext, int userId)
{
  //println("onLostUser - userId: " + userId);
}

void onVisibleUser(SimpleOpenNI curContext, int userId)
{
  ////println("onVisibleUser - userId: " + userId);
}
